/*
 * Main.java
 *
 * 作成日: 2012/01/13
 * Copyright(C)2008 Kyushu Institute of Technology., All right reserved. 
 */
package jp.ac.kyutech.SRP;

import java.io.File;
import java.io.Reader;
import java.util.List;

import org.apache.commons.cli.CommandLine;
import org.apache.commons.cli.Options;

import bsh.Interpreter;

/**
 * SDLEngine CUIメインクラスです
 */
public class Main {

    /**
     * @param args
     */
    public static void main(String[] args) throws Exception {
        Thread.setDefaultUncaughtExceptionHandler(new Thread.UncaughtExceptionHandler() {
            public void uncaughtException(Thread t, Throwable e) {
                e.printStackTrace();
            }
        });
        
        Options options = new Options();
        options.addOption("n", false, "Without builtin scripts.");
        CommandLine cl = new org.apache.commons.cli.BasicParser().parse(options, args);
        
        List<Reader> readers = new java.util.ArrayList<Reader>();
        if (cl.hasOption("n") == false) {
            readers.add(new java.io.InputStreamReader(
                    Thread.currentThread().getContextClassLoader().getResourceAsStream(
                            "jp/ac/kyutech/SRP/Scripting/Scripts/setup.bsh"), "UTF-8"));
        }
        if (args != null) {
            for (String arg: args) {
                readers.add(new java.io.InputStreamReader(new java.io.FileInputStream(new File(arg)), "UTF-8"));
            }
        }
        Interpreter bsh = new Interpreter(new ChainedReader(readers.toArray(new Reader[0])), System.out, System.err, false);
        bsh.setExitOnEOF(false);
        bsh.run();
    }

}
