// -*- Java -*-
/*!
 * @file  ConsoleInImpl.java
 * @brief 'Console input component'
 * @date  $Date$
 *
 * $Id$
 */
// -*- Package Declaration -*-
import java.io.BufferedReader;

import jp.go.aist.rtm.RTC.DataFlowComponentBase;
import jp.go.aist.rtm.RTC.Manager;
import jp.go.aist.rtm.RTC.port.OutPort;
import jp.go.aist.rtm.RTC.util.DataRef;
import RTC.TimedLong;
// -*- Import Declaration -*-
public class ConsoleInImpl extends DataFlowComponentBase {

	public ConsoleInImpl(Manager manager) {  
        super(manager);
        // <rtc-template block="initializer">
        m_out_val = new TimedLong();
        m_out = new DataRef<TimedLong>(m_out_val);
        m_outOut = new OutPort<TimedLong>("out", m_out);
        // </rtc-template>

        // Registration: InPort/OutPort/Service
        // <rtc-template block="registration">
        // Set InPort buffers
        
        // Set OutPort buffer
        try {
			registerOutPort(TimedLong.class, "out", m_outOut);
		} catch (Exception e) {
			e.printStackTrace();
		}
        
        // Set service provider to Ports
        
        // Set service consumers to Ports
        
        // Set CORBA Service Ports
        // </rtc-template>
    }

    // The initialize action (on CREATED->ALIVE transition)
    // formaer rtc_init_entry() 
    @Override
    protected RTC.ReturnCode_t onInitialize() {
        log.info(String.format("Initialized: instance=%s,type=%s", this.getInstanceName(), this.getTypeName()));
        return super.onInitialize();
    }
    // The finalize action (on ALIVE->END transition)
    // formaer rtc_exiting_entry()
//    @Override
//    protected ReturnCode_t onFinalize() {
//        return super.onFinalize();
//    }
    //
    // The startup action when ExecutionContext startup
    // former rtc_starting_entry()
//    @Override
//    protected ReturnCode_t onStartup(int ec_id) {
//        return super.onStartup(ec_id);
//    }
    //
    // The shutdown action when ExecutionContext stop
    // former rtc_stopping_entry()
//    @Override
//    protected ReturnCode_t onShutdown(int ec_id) {
//        return super.onShutdown(ec_id);
//    }
    //
    // The activated action (Active state entry action)
    // former rtc_active_entry()
//    @Override
//    protected ReturnCode_t onActivated(int ec_id) {
//        return super.onActivated(ec_id);
//    }
    //
    // The deactivated action (Active state exit action)
    // former rtc_active_exit()
//    @Override
//    protected ReturnCode_t onDeactivated(int ec_id) {
//        return super.onDeactivated(ec_id);
//    }
    //
    // The execution action that is invoked periodically
    // former rtc_active_do()
    @Override
    protected RTC.ReturnCode_t onExecute(int ec_id) {
        RTC.ReturnCode_t ret = RTC.ReturnCode_t.RTC_OK;
        System.out.print("Please input number: ");
        try {
            BufferedReader reader = new BufferedReader(new java.io.InputStreamReader(System.in));
            String inputStr = reader.readLine();
            int val = Integer.valueOf(inputStr);
            m_out.v.data = val;
        } catch (Exception e) {
            log.error("Fail to read the value.", e);
        }
        m_outOut.write(m_out_val);
        return ret;
    }
    //
    // The aborting action when main logic error occurred.
    // former rtc_aborting_entry()
//  @Override
//  public ReturnCode_t onAborting(int ec_id) {
//      return super.onAborting(ec_id);
//  }
    //
    // The error action in ERROR state
    // former rtc_error_do()
//    @Override
//    public ReturnCode_t onError(int ec_id) {
//        return super.onError(ec_id);
//    }
    //
    // The reset action that is invoked resetting
    // This is same but different the former rtc_init_entry()
    @Override
    protected RTC.ReturnCode_t onReset(int ec_id) {
        return RTC.ReturnCode_t.RTC_OK;
    }
    //
    // The state update action that is invoked after onExecute() action
    // no corresponding operation exists in OpenRTm-aist-0.2.0
//    @Override
//    protected ReturnCode_t onStateUpdate(int ec_id) {
//        return super.onStateUpdate(ec_id);
//    }
    //
    // The action that is invoked when execution context's rate is changed
    // no corresponding operation exists in OpenRTm-aist-0.2.0
//    @Override
//    protected ReturnCode_t onRateChanged(int ec_id) {
//        return super.onRateChanged(ec_id);
//    }
//

    // <sdl-template>
    // </sdl-template>
    
    // DataInPort declaration
    // <rtc-template block="inport_declare">
    
    // </rtc-template>

    // DataOutPort declaration
    // <rtc-template block="outport_declare">
    protected TimedLong m_out_val;
    protected DataRef<TimedLong> m_out;
    protected OutPort<TimedLong> m_outOut;
    
    // </rtc-template>

    // CORBA Port declaration
    // <rtc-template block="corbaport_declare">
    
    // </rtc-template>

    // Service declaration
    // <rtc-template block="service_declare">
    
    // </rtc-template>

    // Consumer declaration
    // <rtc-template block="consumer_declare">
    
    // </rtc-template>

    // <sdl-template>
    /**
     * logger
     */
    private static org.apache.commons.logging.Log log = org.apache.commons.logging.LogFactory.getLog(ConsoleInImpl.class);
    // </sdl-template>
    
    public jp.go.aist.rtm.RTC.port.PortAdmin get_port_admin() {
        return this.m_portAdmin;
    }
    
}
