package jp.go.aist.hrp.simulator;


/**
* jp/go/aist/hrp/simulator/ViewSimulatorOperations.java .
* IDL-to-Java コンパイラ (ポータブル), バージョン "3.1" で生成
* 生成元: C:/Users/ishimura/workspaces/ai_project/OpenHRP3Client/src/idl/OpenHRP/ViewSimulator.idl
* 2009年2月18日 12時58分37秒 JST
*/


/**
   * @if jp
   * @brief ViewSimulator インターフェース
   *
   * カメラとそれから取得できる画像をシミュレーションします。
   *
   * Controllerからは以下の手順で使用できます。
   * メンバ visionSensor_ にセットされた ViewSimulator に対して、
   * 
   * -# ViewSimulator::getCameraSequenceOf を使用して Camera を取得します。
   * -# Camera::getCameraParameter から取得される CameraParameter で各種情報を調べます。
   *
   * 以下、シミュレーションループ
   *
   * -# Camera::getImageData で ImageDataを取得します。
   * -# このカメラのフォーマットにしたがい、ImageData::longData 等から画像を取得します。
   *
   * @author	Ichitaro Kohara, MSTC
   * @version	1.0(2001.02.22)
   * @else
   * Vision Sensor
   * @author	Ichitaro Kohara, MSTC
   * @version	1.0(2001.02.22)
   * @endif
   */
public interface ViewSimulatorOperations 
{

  /**
       * @if jp
       * サーバを終了します。
       * @else
       * Destory
       * @endif
       */
  void destroy ();

  /**
       * @if jp
       * モデルを読み込みます。
       * @param src キャラクタのモデルファイルURL
       * @param objectName キャラクタ名
       * @else
       * Loat object
       * @param	src			object's URL
       * @param	objectName	object's Name
       * @endif
       */
  void loadObject (String src, String objectName) throws jp.go.aist.hrp.simulator.ViewSimulatorPackage.ViewSimulatorException;

  /**
       * @if jp
       * シミュレータにあるカメラを取得します。
       * @param cameras カメラ配列
       * @return カメラの台数
       * @else
       * Get cameras loaded in simulator
       * @param	cameras		cameras
       * @return	number of cameras
       * @endif
       */
  void getCameraSequence (jp.go.aist.hrp.simulator.CameraSequenceHolder cameras);

  /**
       * @if jp
       * キャラクタにあるカメラを取得します。
       * @param objectName キャラクタ名
       * @param cameras カメラ配列
       * @endif
       */
  void getCameraSequenceOf (String objectName, jp.go.aist.hrp.simulator.CameraSequenceHolder cameras);

  /**
       * @if jp
       * シーンを更新します。
       * @param state 新しい WorldState
       * @else
       * Update scene
       * @param	state	WorldState
       * @endif
       */
  void updateScene (jp.go.aist.hrp.simulator.WorldState state);
} // interface ViewSimulatorOperations
