package jp.go.aist.hrp.simulator;


/**
* jp/go/aist/hrp/simulator/_CollisionDetectorStub.java .
* IDL-to-Java コンパイラ (ポータブル), バージョン "3.1" で生成
* 生成元: C:/Users/ishimura/workspaces/ai_project/OpenHRP3Client/src/idl/OpenHRP/CollisionDetector.idl
* 2009年2月18日 12時58分36秒 JST
*/


/**
   * @if jp
   * CollisionDetector インターフェース
   *
   * このサーバは衝突検出とその法線ベクトルの算出を行います。
   * 通常、 DynamicsSimulator から呼び出されるため、直接このサーバにアクセスする必要はありません。
   * @endif
   */
public class _CollisionDetectorStub extends org.omg.CORBA.portable.ObjectImpl implements jp.go.aist.hrp.simulator.CollisionDetector
{

  public void destroy ()
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("destroy", true);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                destroy (        );
            } finally {
                _releaseReply ($in);
            }
  } // destroy


  /**
       * @if jp
       * @brief キャラクタを追加します。
       * @param   charName    キャラクタ名
       * @param   model	    モデル情報
       * @else
       * Adding Objects
       * @param   charName    Character Name
       * @param   model	    model information
       * @endif
      */
  public void addModel (String charName, jp.go.aist.hrp.simulator.CharacterInfo model)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("addModel", true);
                $out.write_string (charName);
                jp.go.aist.hrp.simulator.CharacterInfoHelper.write ($out, model);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                addModel (charName, model        );
            } finally {
                _releaseReply ($in);
            }
  } // addModel


  /**
       * @if jp
       * @brief 干渉チェックペアを追加します。
       * @param   colPair       干渉チェックペア
       * @param   convexsize1   ペアのうち、1つ目を凸包集合に変換するか
       * @param   convexsize2   ペアのうち、2つ目を凸包集合に変換するか
       * @else
       * Adding Polygon Set Pairs
       * @param   colPair       Collision Pair
       * @param   convexsize1   Flag to set whether object1 
       *  			      should be converted to a set of Convexes
       * @param   convexsize2   Flag to set whether object2
       * 			      should be converted to a set of Convexes
       * @endif
      */
  public void addCollisionPair (jp.go.aist.hrp.simulator.LinkPair colPair, boolean convexsize1, boolean convexsize2)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("addCollisionPair", true);
                jp.go.aist.hrp.simulator.LinkPairHelper.write ($out, colPair);
                $out.write_boolean (convexsize1);
                $out.write_boolean (convexsize2);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                addCollisionPair (colPair, convexsize1, convexsize2        );
            } finally {
                _releaseReply ($in);
            }
  } // addCollisionPair


  /**
       * @if jp
       * @brief ペアを取り除きます。
       * @param colPair 取り除くペア
       * @else
       * Delete a pair of Polygon Sets
       * @param   colPair       Collision Pair
       * @endif
       */
  public void removeCollisionPair (jp.go.aist.hrp.simulator.LinkPair colPair)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("removeCollisionPair", true);
                jp.go.aist.hrp.simulator.LinkPairHelper.write ($out, colPair);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                removeCollisionPair (colPair        );
            } finally {
                _releaseReply ($in);
            }
  } // removeCollisionPair


  /**
       * @if jp
       * 既に設定されたペアから衝突検出を行います。
       * @param checkAll 全てをチェックするか(falseを設定するとひとつ衝突を検出した時点で終了します)
       * @param positions キャラクタの位置/姿勢
       * @param collidedPairs 衝突しているペアの配列(衝突していなければ長さは0)
       * @return ひとつでも衝突していれば true, 衝突していなければ false
       * @else
       * Check for Collision between pre-defined Pairs
       * @param  checkAll     true:  Check All Pairs
       * 		  false: Stop when 1 collision is found
       * @param  characters    Position and Attitude of Object
       * @param  collidedPairs  Array of Pairs that are colliding(If none length is 0)
       * @return true:  At least one pair is colliding
       *      false: No pairs are colliding
       * @endif
       */
  public boolean queryIntersectionForDefinedPairs (boolean checkAll, jp.go.aist.hrp.simulator.CharacterPosition[] positions, jp.go.aist.hrp.simulator.LinkPairSequenceHolder collidedPairs)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("queryIntersectionForDefinedPairs", true);
                $out.write_boolean (checkAll);
                jp.go.aist.hrp.simulator.CharacterPositionSequenceHelper.write ($out, positions);
                $in = _invoke ($out);
                boolean $result = $in.read_boolean ();
                collidedPairs.value = jp.go.aist.hrp.simulator.LinkPairSequenceHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return queryIntersectionForDefinedPairs (checkAll, positions, collidedPairs        );
            } finally {
                _releaseReply ($in);
            }
  } // queryIntersectionForDefinedPairs


  /**
       * @if jp
       * ペアを設定し衝突検出を行います。
       * @param checkAll 全てのペアをチェックするか(falseを設定するとひとつ衝突を検出した時点で終了します)
       * @param checkPairs ペア
       * @param positions キャラクタの位置/姿勢
       * @param collidedPairs 衝突しているペアの配列(衝突していなければ長さは0)
       * @return ひとつでも衝突していれば true, 衝突していなければ false
       * @else
       * Check for Collision between Given Pairs
       *    
       * @param  checkAll     true:  Check All Pairs
       *                     false: Return when 1 collision is found
       * @param  checkPairs   Array of Pairs to check for Collision
       * @param  characters    Position and Attitude of Object
       * @param  collidedPairs  Array of Pairs that are colliding(If none length is 0)
       * @return true:  At least one pair is colliding
       *         false: No pairs are colliding
       * @endif
       */
  public boolean queryIntersectionForGivenPairs (boolean checkAll, jp.go.aist.hrp.simulator.LinkPair[] checkPairs, jp.go.aist.hrp.simulator.CharacterPosition[] positions, jp.go.aist.hrp.simulator.LinkPairSequenceHolder collidedPairs)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("queryIntersectionForGivenPairs", true);
                $out.write_boolean (checkAll);
                jp.go.aist.hrp.simulator.LinkPairSequenceHelper.write ($out, checkPairs);
                jp.go.aist.hrp.simulator.CharacterPositionSequenceHelper.write ($out, positions);
                $in = _invoke ($out);
                boolean $result = $in.read_boolean ();
                collidedPairs.value = jp.go.aist.hrp.simulator.LinkPairSequenceHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return queryIntersectionForGivenPairs (checkAll, checkPairs, positions, collidedPairs        );
            } finally {
                _releaseReply ($in);
            }
  } // queryIntersectionForGivenPairs


  /**
       * @if jp
       * すでに設定したペアの衝突情報を取得します。
       * @param characters キャラクタの位置/姿勢
       * @param colInfos 衝突情報
       * @return ひとつでも衝突していれば true, 衝突していなければ false
       * @else
       * Get Collision State Information of pre-defined Pairs
       *
       * @param  characters    Position of Object
       * @param  colInfos     Collision Information
       * @return true:        At least one pair is colliding
       *         false:       No pairs are colliding
       * @endif
       */
  public boolean queryContactDeterminationForDefinedPairs (jp.go.aist.hrp.simulator.CharacterPosition[] positions, jp.go.aist.hrp.simulator.CollisionSequenceHolder collisions)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("queryContactDeterminationForDefinedPairs", true);
                jp.go.aist.hrp.simulator.CharacterPositionSequenceHelper.write ($out, positions);
                $in = _invoke ($out);
                boolean $result = $in.read_boolean ();
                collisions.value = jp.go.aist.hrp.simulator.CollisionSequenceHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return queryContactDeterminationForDefinedPairs (positions, collisions        );
            } finally {
                _releaseReply ($in);
            }
  } // queryContactDeterminationForDefinedPairs


  /**
       * @if jp
       * ペアを与え衝突情報を取得します。
       * @param checkPairs ペア
       * @param characters キャラクタの位置/姿勢
       * @param colInfos 衝突情報
       * @return ひとつでも衝突していれば true, 衝突していなければ false
       * @else
       * Get Collision State Information for given Pairs
       *
       * @param  checkPairs   Array of pairs to check for collision
       * @param  characters    Position of Object
       * @param  colInfos     Collision Information
       * @return true:        At least one pair is colliding
       *         false:       No pairs are colliding
       * @endif
       */
  public boolean queryContactDeterminationForGivenPairs (jp.go.aist.hrp.simulator.LinkPair[] checkPairs, jp.go.aist.hrp.simulator.CharacterPosition[] positions, jp.go.aist.hrp.simulator.CollisionSequenceHolder collisions)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("queryContactDeterminationForGivenPairs", true);
                jp.go.aist.hrp.simulator.LinkPairSequenceHelper.write ($out, checkPairs);
                jp.go.aist.hrp.simulator.CharacterPositionSequenceHelper.write ($out, positions);
                $in = _invoke ($out);
                boolean $result = $in.read_boolean ();
                collisions.value = jp.go.aist.hrp.simulator.CollisionSequenceHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return queryContactDeterminationForGivenPairs (checkPairs, positions, collisions        );
            } finally {
                _releaseReply ($in);
            }
  } // queryContactDeterminationForGivenPairs


  /**
       * @if jp
       * キャッシュをクリアします。
       * @param url モデルファイルURL
       * @else
       * Clear the Cache
       * @param   url         Data Identifier
       * @endif
       */
  public void clearCache (String url)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("clearCache", true);
                $out.write_string (url);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                clearCache (url        );
            } finally {
                _releaseReply ($in);
            }
  } // clearCache

  // Type-specific CORBA::Object operations
  private static String[] __ids = {
    "IDL:OpenHRP/CollisionDetector:1.0"};

  public String[] _ids ()
  {
    return (String[])__ids.clone ();
  }

  private void readObject (java.io.ObjectInputStream s) throws java.io.IOException
  {
     String str = s.readUTF ();
     String[] args = null;
     java.util.Properties props = null;
     org.omg.CORBA.Object obj = org.omg.CORBA.ORB.init (args, props).string_to_object (str);
     org.omg.CORBA.portable.Delegate delegate = ((org.omg.CORBA.portable.ObjectImpl) obj)._get_delegate ();
     _set_delegate (delegate);
  }

  private void writeObject (java.io.ObjectOutputStream s) throws java.io.IOException
  {
     String[] args = null;
     java.util.Properties props = null;
     String str = org.omg.CORBA.ORB.init (args, props).object_to_string (this);
     s.writeUTF (str);
  }
} // class _CollisionDetectorStub
