package jp.go.aist.hrp.simulator;


/**
* jp/go/aist/hrp/simulator/_ControllerStub.java .
* IDL-to-Java コンパイラ (ポータブル), バージョン "3.1" で生成
* 生成元: C:/Users/ishimura/workspaces/ai_project/OpenHRP3Client/src/idl/OpenHRP/Controller.idl
* 2009年2月18日 12時58分36秒 JST
*/


/**
	 * @if jp
	 * @brief Controller インターフェース。
	 *
	 * 制御ソフトの役割を果たします。 Controller は以下の流れを行うように作成してください。
	 *
	 * -# コンストラクタで起動時の初期化
	 * -# start() でシミュレーション開始時の初期化
	 * -# input() でシミュレータからセンサ情報を得る
	 * -# control() センサ情報から制御計算を行う
	 * -# output() でアクチュエータに情報をセットする
	 * 
	 * @note 今後OpenHRPのコントローラはOpenRTMのコンポーネントとして作成するのが標準となります。
	 * 従って、一般的な使用においては本インタフェースを直接使う必要はありません。
	 *
	 * @else
	 * Controller Interface
	 * @endif
	 */
public class _ControllerStub extends org.omg.CORBA.portable.ObjectImpl implements jp.go.aist.hrp.simulator.Controller
{


  /**
  		 * @if jp
  		 * @brief DynamicsSimulator をセットする。
  		 *
  		 * クライアントが Controller サーバを使用する際、 DynamicsSimulator への参照をセットします。
  		 * @param dynamicssimulator_ DynamicsSimulator への参照
  		 * @endif
  		 */
  public void setDynamicsSimulator (jp.go.aist.hrp.simulator.DynamicsSimulator dynamicssimulator_)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("setDynamicsSimulator", true);
                jp.go.aist.hrp.simulator.DynamicsSimulatorHelper.write ($out, dynamicssimulator_);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                setDynamicsSimulator (dynamicssimulator_        );
            } finally {
                _releaseReply ($in);
            }
  } // setDynamicsSimulator


  /**
  		 * @if jp
  		 * @brief ViewSimulatorをセットする。
  		 *
  		 * setDynamicsSimulator() と同様に ViewSimulator を使用する Controller に
  		 * 接続する際はこのメソッドでセットします。
  		 *
  		 * @param viewsimulator_ ViewSimulator への参照
  		 * @endif
  		 */
  public void setViewSimulator (jp.go.aist.hrp.simulator.ViewSimulator viewsimulator_)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("setViewSimulator", true);
                jp.go.aist.hrp.simulator.ViewSimulatorHelper.write ($out, viewsimulator_);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                setViewSimulator (viewsimulator_        );
            } finally {
                _releaseReply ($in);
            }
  } // setViewSimulator


  /**
  		 * @if jp
  		 * @brief シミュレーションループが始まる前に１回呼ばれます。
  		 *
  		 * シミュレーション前の初期化はここに書いてください。
  		 * @else
  		 * This method is called just before beginning periodic calls of control().
  		 *
  		 * Initialization that requires the initial state of a robot
  		 * should be done in this method.
  		 * @endif
  		 */
  public void start ()
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("start", true);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                start (        );
            } finally {
                _releaseReply ($in);
            }
  } // start


  /**
  		 * @if jp
  		 * @brief 制御計算を行います。
  		 *
  		 * シミュレーションループにおいて input() で取得した情報を使用して計算を行い、 output() で出力します。
  		 * @endif
  		 */
  public void control ()
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("control", true);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                control (        );
            } finally {
                _releaseReply ($in);
            }
  } // control


  /**
  		 * @if jp
  		 * @brief センサ情報の取得を行います。
  		 *
  		 * DynamicsSimulator::getCharacterSensorState() 等を使用してセンサ情報を取得します。
  		 * @endif
  		 */
  public void input ()
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("input", true);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                input (        );
            } finally {
                _releaseReply ($in);
            }
  } // input


  /**
  		 * @if jp
  		 * @brief アクチュエータなどへ情報を出力します。
  		 *
  		 * DynamicsSimulator::setCharacterLinkData() 等を使用してシミュレータへ情報を出力します。
  		 * @endif
  		 */
  public void output ()
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("output", true);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                output (        );
            } finally {
                _releaseReply ($in);
            }
  } // output


  /**
  		 * @if jp
  		 * シミュレーションループが終了した際に呼ばれます。
  		 * @else
  		 * This method is called when the control loop is finished.
  		 * @endif
  		 */
  public void stop ()
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("stop", true);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                stop (        );
            } finally {
                _releaseReply ($in);
            }
  } // stop


  /**
  		 * @if jp
  		 * サーバを終了します。
  		 * @endif
  		 */
  public void destroy ()
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("destroy", true);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                destroy (        );
            } finally {
                _releaseReply ($in);
            }
  } // destroy


  /**
  		 * @if jp
  		 * controllerのtimeStepを設定します。
  		 * @endif
  		 */
  public void setTimeStep (double timeStep)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("setTimeStep", true);
                $out.write_double (timeStep);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                setTimeStep (timeStep        );
            } finally {
                _releaseReply ($in);
            }
  } // setTimeStep

  // Type-specific CORBA::Object operations
  private static String[] __ids = {
    "IDL:OpenHRP/Controller:1.0"};

  public String[] _ids ()
  {
    return (String[])__ids.clone ();
  }

  private void readObject (java.io.ObjectInputStream s) throws java.io.IOException
  {
     String str = s.readUTF ();
     String[] args = null;
     java.util.Properties props = null;
     org.omg.CORBA.Object obj = org.omg.CORBA.ORB.init (args, props).string_to_object (str);
     org.omg.CORBA.portable.Delegate delegate = ((org.omg.CORBA.portable.ObjectImpl) obj)._get_delegate ();
     _set_delegate (delegate);
  }

  private void writeObject (java.io.ObjectOutputStream s) throws java.io.IOException
  {
     String[] args = null;
     java.util.Properties props = null;
     String str = org.omg.CORBA.ORB.init (args, props).object_to_string (this);
     s.writeUTF (str);
  }
} // class _ControllerStub
