package jp.go.aist.hrp.simulator;


/**
* jp/go/aist/hrp/simulator/_OnlineViewerStub.java .
* IDL-to-Java コンパイラ (ポータブル), バージョン "3.1" で生成
* 生成元: C:/Users/ishimura/workspaces/ai_project/OpenHRP3Client/src/idl/OpenHRP/OnlineViewer.idl
* 2009年2月18日 12時58分37秒 JST
*/


/**
   * @if jp
   * OnlineViewer インターフェース
   *
   * GrxUI の 3DView をクライアントプログラムから表示させる際に使用します。
   *
   * load() で読み込んだモデルに対して update() で情報を与えることでアニメーションします。
   *
   * また、 update() を使用すると情報は記録され、後で再生することもできます。
   */
public class _OnlineViewerStub extends org.omg.CORBA.portable.ObjectImpl implements jp.go.aist.hrp.simulator.OnlineViewer
{


  /**
       * @if jp
       * 表示内容を更新します
       *
       * 内容は記録され、後で再生し直すことができます。
       * @param state 更新する表示内容の情報
       * @else
       * Update Display
       * @endif
       */
  public void update (jp.go.aist.hrp.simulator.WorldState state)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("update", true);
                jp.go.aist.hrp.simulator.WorldStateHelper.write ($out, state);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                update (state        );
            } finally {
                _releaseReply ($in);
            }
  } // update


  /**
       * @if jp
       * モデルの読み込みを行います。
       * @param name モデル名
       * @param url モデルファイルURL
       * @endif 
       */
  public void load (String name, String url)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("load", true);
                $out.write_string (name);
                $out.write_string (url);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                load (name, url        );
            } finally {
                _releaseReply ($in);
            }
  } // load


  /**
       * @if jp
       * 記録されたいままでの更新をクリアします。
       * @endif
       */
  public void clearLog ()
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("clearLog", true);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                clearLog (        );
            } finally {
                _releaseReply ($in);
            }
  } // clearLog


  /**
       * @if jp
       * データをクリアします。
       * @endif
       */
  public void clearData ()
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("clearData", true);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                clearData (        );
            } finally {
                _releaseReply ($in);
            }
  } // clearData


  /**
       * @if jp
       * 表示内容を更新します。 update() とは違い、更新内容を記録しません。
       * @param state 更新する表示内容の情報
       * @else
       * state display without recording  '03 Apr.4  s.kajita
       * @endif
       */
  public void drawScene (jp.go.aist.hrp.simulator.WorldState state)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("drawScene", true);
                jp.go.aist.hrp.simulator.WorldStateHelper.write ($out, state);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                drawScene (state        );
            } finally {
                _releaseReply ($in);
            }
  } // drawScene


  /**
       * @if jp
       * 線の幅を設定します。
       * @endif
       */
  public void setLineWidth (float width)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("setLineWidth", true);
                $out.write_float (width);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                setLineWidth (width        );
            } finally {
                _releaseReply ($in);
            }
  } // setLineWidth


  /**
       * @if jp
       * スケールを設定します。
       * @endif
       */
  public void setLineScale (float scale)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("setLineScale", true);
                $out.write_float (scale);
                $in = _invoke ($out);
                return;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                setLineScale (scale        );
            } finally {
                _releaseReply ($in);
            }
  } // setLineScale


  /**
       * @if jp
       * 
       * @endif
       */
  public boolean getPosture (String robotId, jp.go.aist.hrp.simulator.DblSequenceHolder posture)
  {
            org.omg.CORBA.portable.InputStream $in = null;
            try {
                org.omg.CORBA.portable.OutputStream $out = _request ("getPosture", true);
                $out.write_string (robotId);
                $in = _invoke ($out);
                boolean $result = $in.read_boolean ();
                posture.value = jp.go.aist.hrp.simulator.DblSequenceHelper.read ($in);
                return $result;
            } catch (org.omg.CORBA.portable.ApplicationException $ex) {
                $in = $ex.getInputStream ();
                String _id = $ex.getId ();
                throw new org.omg.CORBA.MARSHAL (_id);
            } catch (org.omg.CORBA.portable.RemarshalException $rm) {
                return getPosture (robotId, posture        );
            } finally {
                _releaseReply ($in);
            }
  } // getPosture

  // Type-specific CORBA::Object operations
  private static String[] __ids = {
    "IDL:OpenHRP/OnlineViewer:1.0"};

  public String[] _ids ()
  {
    return (String[])__ids.clone ();
  }

  private void readObject (java.io.ObjectInputStream s) throws java.io.IOException
  {
     String str = s.readUTF ();
     String[] args = null;
     java.util.Properties props = null;
     org.omg.CORBA.Object obj = org.omg.CORBA.ORB.init (args, props).string_to_object (str);
     org.omg.CORBA.portable.Delegate delegate = ((org.omg.CORBA.portable.ObjectImpl) obj)._get_delegate ();
     _set_delegate (delegate);
  }

  private void writeObject (java.io.ObjectOutputStream s) throws java.io.IOException
  {
     String[] args = null;
     java.util.Properties props = null;
     String str = org.omg.CORBA.ORB.init (args, props).object_to_string (this);
     s.writeUTF (str);
  }
} // class _OnlineViewerStub
